> ## Documentation Index > Fetch the complete documentation index at: https://support.keypro.fi/llms.txt > Use this file to discover all available pages before exploring further. # Get list of cross connection points > Operation is used to get a list of cross connection points. Available from product version 3.2.8. Cross connection points can be filtered by giving filtering parameters at HTTP querystring (see parameters). ## OpenAPI ````json GET /ccps/ { "openapi": "3.0.4", "info": { "title": "KeyCom REST API", "termsOfService": "https://www.keypro.fi/en/terms-of-service", "contact": { "name": "Keypro Oy", "url": "https://keypro.fi/", "email": "keypro@keypro.fi" }, "license": { "name": "Copyright (C) Keypro Oy. All rights reserved.", "url": "https://www.keypro.fi/" }, "version": "2.0.0" }, "servers": [ { "url": "/api/v2" } ], "tags": [ { "name": "Plan", "description": "Plan related operations." }, { "name": "FreeArea", "description": "FreeArea related operations." }, { "name": "FreeLine", "description": "FreeLine related operations." }, { "name": "FreeText", "description": "FreeText related operations." }, { "name": "FreeTextComponent", "description": "FreeText component related operations." }, { "name": "Address", "description": "Building address related operations." }, { "name": "Apartment", "description": "Building apartments related operations." }, { "name": "Extra Attribute", "description": "Extra attributes related operations." }, { "name": "Extra Value", "description": "Extra attribute values related operations." }, { "name": "EAV Enum", "description": "EAV Enum value related operations." }, { "name": "EAV Enum Group", "description": "EAV Enum group related operations." }, { "name": "External Document", "description": "External documents related operations." }, { "name": "Attached Document", "description": "Attached Documents related operations." }, { "name": "Collections", "description": "Collection related operations." }, { "name": "Source system apartment", "description": "External source system derived apartment related operations." }, { "name": "Source system address", "description": "External source system derived address related operations." }, { "name": "Address alias", "description": "Address aliases related operations" }, { "name": "TxtConstant", "description": "TxtConstants related operations." }, { "name": "Point", "description": "Point objects related operations." }, { "name": "Survey Constant", "description": "Survey Constants related operations." }, { "name": "Survey Point", "description": "Survey Points related operations." }, { "name": "Survey Line String", "description": "Survey Line Strings related operations." }, { "name": "Template Catalog", "description": "Template Catalog related operations." }, { "name": "Route Following", "description": "Route following related operations." }, { "name": "Contact Person", "description": "Contact person related operations." }, { "name": "Contact Person Connection", "description": "Contact person connection related operations." }, { "name": "Telecom premises", "description": "Telecom premises related operations." }, { "name": "Device", "description": "Device related operations." }, { "name": "Device Group", "description": "Device Group related operations." }, { "name": "Splice", "description": "Telecom Splice related operations." }, { "name": "Telecom Conduit", "description": "Telecom Conduit related operations." }, { "name": "Telecom Conduit Link", "description": "Operations related to putting Telecom Cables and Ducts into Conduits." }, { "name": "Telecom Duct", "description": "Telecom Duct related operations." }, { "name": "Telecom Duct Link", "description": "Operations related to putting Telecom Cables into Ducts." }, { "name": "Telecom Conduit Connection", "description": "Operations related to connecting Conduits and endpoints." }, { "name": "Telecom Cable Connection", "description": "Operations related to connecting Cables and endpoints" }, { "name": "Telecom Thread/Port Connection", "description": "Operations related to connecting and disconnecting telecom cable threads and device ports" }, { "name": "Telecom Duct Connection", "description": "Operations related to connecting Telecom Ducts to Telecom Premises or Manhole." }, { "name": "Manhole", "description": "Telecom Manhole related operations." }, { "name": "Cable", "description": "Telecom Cable related operations." }, { "name": "Cable Appendix", "description": "Cable Appendix operations for connecting Cables to loops. Manages the relationship between Cables and loops, automatically adjusting Cable extra_length when appendixes are created, updated, or deleted." }, { "name": "Supercable", "description": "Telecom Supercable related operations." }, { "name": "Cross connection point", "description": "Cross connection point related operations." }, { "name": "Service Area", "description": "Service Area related operations." }, { "name": "Exchange Area", "description": "Exchange Area related operations." }, { "name": "Telecom Area", "description": "Telecom Area related operations." }, { "name": "Routefollower", "description": "Routefollower related operations." }, { "name": "Circuit", "description": "Circuit related operations." }, { "name": "Circuit Location", "description": "Circuit installation location related operations." }, { "name": "Circuit Section", "description": "Circuit section related operations." }, { "name": "Circuit Reservation Data", "description": "Circuit reservation data view and search operations." }, { "name": "Customer", "description": "Customer data related operations." }, { "name": "Passed Services", "description": "Passed Services related operations." }, { "name": "Circuit Connection", "description": "Circuit logical reservations related operations." }, { "name": "Circuit Physical Reservation", "description": "Circuit physical reservations related operations." }, { "name": "Create connections", "description": "Operation used to create new connections." }, { "name": "Terminal type", "description": "Terminal types related operations." }, { "name": "Logical connections", "description": "Logical connections related operations." }, { "name": "Circuit Services", "description": "Operations provided by micro services." }, { "name": "Contract", "description": "Contract related operations." }, { "name": "Contract Link", "description": "Contract link related operations." }, { "name": "Pole", "description": "Pole related operations." }, { "name": "Circuit faults", "description": "Circuit faults related operations." }, { "name": "Duct groups", "description": "Duct groups related operations." }, { "name": "Duct group rows", "description": "Duct group rows related operations." }, { "name": "Threads", "description": "Cable thread related operations." }, { "name": "Task", "description": "Task related operations." }, { "name": "Subregion", "description": "Subregion related operations." }, { "name": "SAttribute", "description": "SAttribute related operations." }, { "name": "Fault", "description": "Fault related operations." }, { "name": "Maintenance history", "description": "Maintenance history related operations." }, { "name": "Deflection", "description": "Deflection related operations." }, { "name": "Fault Component", "description": "Fault Component related operations." }, { "name": "Task Comment", "description": "Task comment related operations." }, { "name": "FaultComponentFault", "description": "FaultComponentFault related operations." } ], "paths": { "/ccps/": { "get": { "tags": [ "Cross connection point" ], "summary": "Get list of cross connection points", "description": "Operation is used to get a list of cross connection points. Available from product version 3.2.8.\n\nCross connection points can be filtered by giving filtering parameters at HTTP querystring (see parameters).\n", "operationId": "getCcps", "parameters": [ { "$ref": "#/components/parameters/offsetParam" }, { "$ref": "#/components/parameters/limitParam" }, { "$ref": "#/components/parameters/filterParam" }, { "$ref": "#/components/parameters/orderParam" } ], "responses": { "200": { "description": "A result response object.", "content": { "application/json": { "schema": { "type": "object", "properties": { "Next": { "type": "string", "description": "Url to next page of cross connection points. Null if No next page exist", "format": "url" }, "Previous": { "type": "string", "description": "Url to previous page of cross connection points. Null if No previous page exist", "format": "url" }, "Results": { "type": "array", "items": { "$ref": "#/components/schemas/CCP" }, "description": "List of fetched cross connection points" }, "Total": { "type": "integer", "description": "Total number of cross connection points" } } }, "example": { "Next": null, "Previous": null, "Results": [ { "bitrate": null, "ccpOwner": null, "channelType": null, "connectorNumber": 12, "connectorType": null, "constState": { "availability_end_ts": "2020-12-31T00:00:00", "availability_start_ts": "2020-01-01T00:00:00", "available": true, "groupname": "KN_CONST_STATE", "id": 6050, "list_url": "https://keycom.example.fi/api/v2/txt_constants/groupname/KN_CONST_STATE/", "logical_txt": "Valmis", "num_value": 10.1, "num_value2": 20.2, "num_value3": 30.3, "num_value4": 40.4, "txt": "Valmis" }, "freeStatus": 1, "functionality": "", "id": 595250, "name": "12", "parent": null, "priority": null, "remarks": "", "services": [ { "cableLength": null, "id": 10, "servicegroups": [ { "id": 401, "name": "Test", "priority": 2, "remarks": "testaus", "sprimary": 1 } ], "technology": { "availability_end_ts": "2020-12-31T00:00:00", "availability_start_ts": "2020-01-01T00:00:00", "available": true, "groupname": "CABLE_TECHNOLOGY", "id": 30, "list_url": "https://keycom.example.fi/api/v2/txt_constants/groupname/CABLE_TECHNOLOGY/", "logical_txt": "Kuitu", "num_value": 10.1, "num_value2": 20.2, "num_value3": 30.3, "num_value4": 40.4, "txt": "Kuitu" }, "usage": { "availability_end_ts": "2020-12-31T00:00:00", "availability_start_ts": "2020-01-01T00:00:00", "available": true, "groupname": "USAGE", "id": 14970, "list_url": "https://keycom.example.fi/api/v2/txt_constants/groupname/USAGE/", "logical_txt": "50 VOIP-liittymä", "num_value": 10.1, "num_value2": 20.2, "num_value3": 30.3, "num_value4": 40.4, "txt": "50 VOIP-liittymä" } } ], "signalDirection": null, "startThread": 23, "subCcpOrder": null, "subchannelsExist": "", "technology": 0, "terminal": "https://keycom.example.fi/api/v2/devices/3390/" } ], "Total": 1 } } } }, "401": { "$ref": "#/components/responses/Http401" } }, "security": [ { "Token": [] } ] } } }, "components": { "parameters": { "offsetParam": { "name": "offset", "in": "query", "description": "Offset to start returning results.", "schema": { "minimum": 0, "type": "integer" } }, "limitParam": { "name": "limit", "in": "query", "description": "Limit number of results returned. Set to -1 to use maximum limit set in the environment. Default limit will be used if parameter is not specified. Special value -1 is available from product version 3.2.18.", "schema": { "minimum": 1, "type": "integer" } }, "filterParam": { "name": "__any of the object fields__", "in": "query", "description": "Filters list by selected object field value.\nSupports structured queries via +++__+++ delimiter.\nSupports ending keywords via +++__+++ delimiter:\n- For string fields: istartswith, startswith, iendswith, endswith, contains, icontains, isnull\n- For numerics: gt, lt, gte, lte, isnull\n- For spatial fields: contains, isnull, within, intersects, disjoint, touches, overlaps, covers, coveredby\n**Examples:** `+++usage_state__txt__istartswith=in+++` ,\n`+++plan__state__txt__startswith=In+++` , `+++creation_date__gte=2019-01-02T15:32:01+++`,\n`+++location__within=POLYGON ((641503.89 6944059.81, 641406.52 6943933.87, 641369.48 6943772.48, 641474.25 6943704.74, 641873.78 6943735.96, 641848.38 6943975.15, 641607.08 6944167.76, 641653.11 6944102.15, 641503.89 6944059.81))+++`\nSupports exclusive queries by field value using a not-operator preceding the field lookup:\n**Examples:** `+++not__type__txt__istartswith=Tie+++` , `+++not__id=1390+++`\n", "schema": { "type": "string" } }, "orderParam": { "name": "orderby", "in": "query", "description": "Selects the object field to order the returned objects by.\nCan be used to sort in reverse order with '-' prefix.\nCan have several ordering rules separated by comma.\nCan be used only for object own fields and does not support structured queries.\n**Example:** `orderby=creator,-creation_date`\n", "schema": { "type": "string" } } }, "schemas": { "CCP": { "required": [ "name", "startThread", "terminal" ], "type": "object", "properties": { "bitrate": { "$ref": "#/components/schemas/Bitrate" }, "ccpOwner": { "$ref": "#/components/schemas/CcpOwner" }, "channelType": { "$ref": "#/components/schemas/ChannelType" }, "connectorType": { "$ref": "#/components/schemas/ConnectorType" }, "constState": { "$ref": "#/components/schemas/ConstructionState" }, "freeStatus": { "enum": [ 1, 0 ], "type": "integer", "description": "Defines if cross connection point is free" }, "functionality": { "type": "string", "description": "Functionality" }, "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "name": { "type": "string", "description": "Name of cross connection point" }, "parent": { "type": "string", "description": "Url to fetch details of parent cross connection point", "format": "url" }, "priority": { "$ref": "#/components/schemas/CcpPriority" }, "remarks": { "type": "string", "description": "Remarks" }, "services": { "type": "array", "items": { "$ref": "#/components/schemas/ServiceType" }, "description": "List of this cross connection point's services", "readOnly": true }, "signalDirection": { "$ref": "#/components/schemas/SignalDirection" }, "startThread": { "type": "integer", "description": "Start thread" }, "subCcpOrder": { "type": "integer", "description": "Sub connector order" }, "subchannelsExist": { "enum": [ 1, 0 ], "type": "string", "description": "Defines whether subchannels exist or not" }, "technology": { "enum": [ 1, 0 ], "type": "integer", "description": "Technology of ccp. 1 for Fiber, 0 for Copper." }, "terminal": { "type": "string", "description": "url of cross connection point terminal/device", "format": "url" } } }, "Bitrate": { "type": "object", "properties": { "description": { "type": "string", "description": "Bitrate description", "readOnly": true }, "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "rate": { "type": "integer", "description": "Bitrate value", "readOnly": true } } }, "CcpOwner": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "KN_CCP_OWNER" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Cross connection point owner" }, "ChannelType": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "CHANNEL_TYPE" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Cross connection point channel type" }, "ConnectorType": { "required": [ "abbreviation", "description", "threadCount" ], "type": "object", "properties": { "abbreviation": { "type": "string", "description": "Abbreviation" }, "attenuation": { "type": "number", "description": "Attenuation", "format": "float" }, "description": { "type": "string", "description": "Description" }, "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "technologyId": { "enum": [ 1, 0 ], "type": "integer", "description": "Technology id." }, "threadCount": { "type": "integer", "description": "Thread count" } } }, "ConstructionState": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "KN_CONST_STATE" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Txt constants construction state" }, "CcpPriority": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "CCP_PRIORITY" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Cross connection point priority" }, "ServiceType": { "required": [ "usage", "technology" ], "type": "object", "properties": { "cableLength": { "type": "number", "description": "Cable length", "format": "float" }, "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "servicegroups": { "type": "array", "items": { "$ref": "#/components/schemas/ServiceGroup" }, "description": "List of service groups for this service", "readOnly": true }, "technology": { "$ref": "#/components/schemas/ServiceTypeTechnology" }, "usage": { "$ref": "#/components/schemas/ServiceTypeUsage" } } }, "SignalDirection": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "KN_SIGNAL_DIR" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Cross connection point signal direction" }, "ErrorDetailsResponse": { "required": [ "details" ], "type": "object", "properties": { "details": { "type": "string", "description": "Detailed description of error" } }, "description": "Standard error response payload" }, "ServiceGroup": { "required": [ "name", "remarks" ], "type": "object", "properties": { "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "name": { "type": "string", "description": "Name of service type group" }, "priority": { "type": "integer", "description": "Priority" }, "remarks": { "type": "string", "description": "Remarks" }, "sprimary": { "type": "integer", "description": "Sprimary" } } }, "ServiceTypeTechnology": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "CABLE_TECHNOLOGY" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Cable type technology" }, "ServiceTypeUsage": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "USAGE", "CCP_SERVICE" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Service usage" } }, "responses": { "Http401": { "description": "Authentication credentials are missing or invalid", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorDetailsResponse" }, "example": { "details": "Authentication credentials were not provided" } } } } }, "securitySchemes": { "Token": { "type": "apiKey", "description": "Token issued for API consumer.", "name": "Authorization", "in": "header" } } } } ````